/*
 * BottomOfTheStackSymbol.h
 *
 *  Created on: Jun 19, 2014
 *      Author: Jan Travnicek
 */

#ifndef BOTTOM_OF_THE_STACK_SYMBOL_H_
#define BOTTOM_OF_THE_STACK_SYMBOL_H_

#include "Symbol.h"

namespace alphabet {

/**
 * Represents blank symbol in an alphabet.
 */
class BottomOfTheStackSymbol : public std::acceptor<BottomOfTheStackSymbol, VisitableSymbolBase, std::acceptor<BottomOfTheStackSymbol, alib::VisitableObjectBase, SymbolBase> > {
public:
	/**
	 * Creates a blank symbol.
	 * @param symbol name of the symbol
	 */
	explicit BottomOfTheStackSymbol();

	virtual SymbolBase* clone() const;
	virtual SymbolBase* plunder() &&;

	virtual int compare(const ObjectBase& other) const {
		return -other.compare(*this);
	}

	virtual int compare(const BottomOfTheStackSymbol& other) const;

	virtual void operator>>(std::ostream& out) const;

	virtual operator std::string () const;

	virtual int selfTypeId() const {
		return typeId<BottomOfTheStackSymbol>();
	}

	static BottomOfTheStackSymbol BOTTOM_OF_THE_STACK;
};

} /* namespace alphabet */

namespace std {

template<>
struct compare<alphabet::BottomOfTheStackSymbol> {
	int operator()(const alphabet::BottomOfTheStackSymbol& first, const alphabet::BottomOfTheStackSymbol& second) const {
		return first.compare(second);
	}
};

} /* namespace std */

#endif /* BOTTOM_OF_THE_STACK_SYMBOL_H_ */
