/*
 * ExceptionToXMLComposer.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnciek
 */

#ifndef EXCEPTION_TO_XML_COMPOSER_H_
#define EXCEPTION_TO_XML_COMPOSER_H_

#include <list>
#include "AlibException.h"
#include "../sax/Token.h"

namespace alib {

template<typename T>
struct xmlApi;

} /* namespace alib */

namespace exception {

/**
 * This class contains methods to print XML representation of string to the output stream.
 */
class ExceptionToXMLComposer {
	/**
	 * Prints XML representation of AlibException to the output stream.
	 * @param string Exception to print
	 * @param out output stream to which print the String
	 */
	void compose(std::list<sax::Token>& out, const AlibException& exception) const;

	template<typename T> friend class alib::xmlApi;
};

} /* namespace exception */

#endif /* EXCEPTION_TO_XML_COMPOSER_H_ */
