/*
 * GrammarFromStringLexer.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#ifndef GRAMMAR_FROM_STRING_LEXER_H_
#define GRAMMAR_FROM_STRING_LEXER_H_

#include <string>
#include <sstream>

namespace grammar {

class GrammarFromStringLexer {
public:
	enum class TokenType {
		SET_BEGIN,
		SET_END,
		COMMA,
		TUPLE_BEGIN,
		TUPLE_END,
		SEPARATOR,
		EPSILON,
		MAPS_TO,
		RIGHT_RG,
		CNF,
		TEOF,
		ERROR,
	};

	struct Token {
		TokenType type;
		std::string value;
		std::string raw;
	};

	Token next(std::istream& input) const;
	void putback(std::istream&, Token token) const;
};

} /* namepsace grammar */

#endif /* GRAMMAR_FROM_STRING_LEXER_H_ */
