#include "GrammarToStringComposer.h"
#include <sstream>
#include "ContextFree/CNF.h"

#include "../StringApi.hpp"

namespace grammar {

void GrammarToStringComposer::compose(std::ostream& output, const Grammar& grammar) const {
	grammar.getData().Accept((void*) &output, *this);
}

void GrammarToStringComposer::compose(std::ostream& output, const LeftLG& grammar) const {
	// TODO
}

void GrammarToStringComposer::compose(std::ostream& output, const LeftRG& grammar) const {
	// TODO
}

void GrammarToStringComposer::compose(std::ostream& output, const RightLG& grammar) const {
	// TODO
}

void GrammarToStringComposer::compose(std::ostream& output, const RightRG& grammar) const {
	// TODO
}

void GrammarToStringComposer::compose(std::ostream& output, const LG& grammar) const {
	// TODO
}

void GrammarToStringComposer::compose(std::ostream& output, const CFG& grammar) const {
	// TODO
}

void GrammarToStringComposer::compose(std::ostream& output, const EpsilonFreeCFG& grammar) const {
	// TODO
}

void GrammarToStringComposer::compose(std::ostream& output, const CNF& grammar) const {
	bool first;

	output << "CNF (" << std::endl;

	output << "{";
	first = false;
	for(const auto& symbol : grammar.getNonterminalAlphabet() ) {
		if(first)
			output << ", ";
		else
			first = true;
		alib::stringApi<alphabet::Symbol>::compose(output, symbol);
	}
	output << "}," << std::endl;
	output << "{";
	first = false;
	for(const auto& symbol : grammar.getTerminalAlphabet() ) {
		if(first)
			output << ", ";
		else
			first = true;
		alib::stringApi<alphabet::Symbol>::compose(output, symbol);
	}
	output << "}," << std::endl;
	output << "{ ";
	first = true;
	for(const auto& rule : grammar.getRawRules() ) {
		if(first)
			first = false;
		else
			output << "," << std::endl << "  ";
		alib::stringApi<alphabet::Symbol>::compose(output, rule.first);
		output << " ->";
		bool innerFirst = true;
		for(const auto& rhs : rule.second) {
			if(innerFirst)
				innerFirst = false;
			else
				output << " |";
			for(const auto& symbol : rhs) {
				output << " ";
				alib::stringApi<alphabet::Symbol>::compose(output, symbol);
			}
		}
	}
	output << "}," << std::endl;
	alib::stringApi<alphabet::Symbol>::compose(output, grammar.getInitialSymbol());
	output << ")" << std::endl;
}

void GrammarToStringComposer::compose(std::ostream& output, const GNF& grammar) const {
	// TODO
}

void GrammarToStringComposer::compose(std::ostream& output, const CSG& grammar) const {
	// TODO
}

void GrammarToStringComposer::compose(std::ostream& output, const NonContractingGrammar& grammar) const {
	// TODO
}

void GrammarToStringComposer::compose(std::ostream& output, const ContextPreservingUnrestrictedGrammar& grammar) const {
	// TODO
}

void GrammarToStringComposer::compose(std::ostream& output, const UnrestrictedGrammar& grammar) const {
	// TODO
}

void GrammarToStringComposer::Visit(void* data, const LeftLG& grammar) const {
	this->compose(*((std::ostream*) data), grammar);
}

void GrammarToStringComposer::Visit(void* data, const LeftRG& grammar) const {
	this->compose(*((std::ostream*) data), grammar);
}

void GrammarToStringComposer::Visit(void* data, const RightLG& grammar) const {
	this->compose(*((std::ostream*) data), grammar);
}

void GrammarToStringComposer::Visit(void* data, const RightRG& grammar) const {
	this->compose(*((std::ostream*) data), grammar);
}

void GrammarToStringComposer::Visit(void* data, const LG& grammar) const {
	this->compose(*((std::ostream*) data), grammar);
}

void GrammarToStringComposer::Visit(void* data, const CFG& grammar) const {
	this->compose(*((std::ostream*) data), grammar);
}

void GrammarToStringComposer::Visit(void* data, const EpsilonFreeCFG& grammar) const {
	this->compose(*((std::ostream*) data), grammar);
}

void GrammarToStringComposer::Visit(void* data, const CNF& grammar) const {
	this->compose(*((std::ostream*) data), grammar);
}

void GrammarToStringComposer::Visit(void* data, const GNF& grammar) const {
	this->compose(*((std::ostream*) data), grammar);
}

void GrammarToStringComposer::Visit(void* data, const CSG& grammar) const {
	this->compose(*((std::ostream*) data), grammar);
}

void GrammarToStringComposer::Visit(void* data, const NonContractingGrammar& grammar) const {
	this->compose(*((std::ostream*) data), grammar);
}

void GrammarToStringComposer::Visit(void* data, const ContextPreservingUnrestrictedGrammar& grammar) const {
	this->compose(*((std::ostream*) data), grammar);
}

void GrammarToStringComposer::Visit(void* data, const UnrestrictedGrammar& grammar) const {
	this->compose(*((std::ostream*) data), grammar);
}

}
