/*
 * LabelToXMLComposer.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnciek
 */

#ifndef LABEL_TO_XML_COMPOSER_H_
#define LABEL_TO_XML_COMPOSER_H_

#include <list>
#include "Label.h"
#include "../sax/Token.h"

namespace alib {

template<typename T>
struct xmlApi;

} /* namespace alib */

namespace label {

/**
 * This class contains methods to print XML representation of string to the output stream.
 */
class LabelToXMLComposer {
	/**
	 * Prints XML representation of String to the output stream.
	 * @param string String to print
	 * @param out output stream to which print the String
	 */
	void compose(std::list<sax::Token>& out, const LabelBase& label) const;

	/**
	 * Prints XML representation of String to the output stream.
	 * @param string String to print
	 * @param out output stream to which print the String
	 */
	void compose(std::list<sax::Token>& out, const Label& label) const;

	void compose(std::list<sax::Token>& out, const PrimitiveLabel& label) const;
	void compose(std::list<sax::Token>& out, const HexavigesimalLabel& label) const;
	void compose(std::list<sax::Token>& out, const ObjectLabel& label) const;
	void compose(std::list<sax::Token>& out, const LabelSetLabel& label) const;
	void compose(std::list<sax::Token>& out, const LabelPairLabel& label) const;
	void compose(std::list<sax::Token>& out, const UniqueLabel& label) const;

	template<typename T> friend class alib::xmlApi;
};

} /* namespace label */

#endif /* LABEL_TO_XML_COMPOSER_H_ */
