/*
 * ObjectLabel.cpp
 *
 *  Created on: Mar 26, 2013
 *      Author:Jan Travnicek 
 */

#include "ObjectLabel.h"

namespace label {

ObjectLabel::ObjectLabel(const alib::Object& label) : label(label) {

}

ObjectLabel::ObjectLabel(alib::Object&& label) : label(std::move(label)) {

}

LabelBase* ObjectLabel::clone() const {
	return new ObjectLabel(*this);
}

LabelBase* ObjectLabel::plunder() && {
	return new ObjectLabel(std::move(*this));
}

const alib::Object& ObjectLabel::getData() const {
	return label;
}

int ObjectLabel::compare(const ObjectLabel& other) const {
	return label.getData().compare(other.label.getData());
}

void ObjectLabel::operator>>(std::ostream& out) const {
	out << "(ObjectLabel " << label << ")";
}

ObjectLabel::operator std::string() const {
	return (std::string) label;
}

} /* namespace label */

