/*
 * ObjectFromXMLParser.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#ifndef OBJECT_FROM_XML_PARSER_H_
#define OBJECT_FROM_XML_PARSER_H_

#include "../sax/FromXMLParserHelper.h"
#include <set>
#include "Object.h"
#include "../sax/Token.h"
#include "../label/Label.h"

namespace alib {

template<typename T>
struct xmlApi;

} /* namespace alib */

namespace alib {

/**
 * Parser used to get String from XML parsed into list of tokens.
 */
class ObjectFromXMLParser : public sax::FromXMLParserHelper {
	Object parseObject(std::list<sax::Token>& input) const;
	Void parseVoid(std::list<sax::Token>& input) const;

	template<typename T> friend class alib::xmlApi;
public:
	bool first(const std::list<sax::Token>& input) const;
};

} /* namespace alib */

#endif /* OBJECT_FROM_XML_PARSER_H_ */
