/*
 * ObjectToXMLComposer.cpp
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#include "ObjectToXMLComposer.h"

#include "../XmlApi.hpp"

namespace alib {

void ObjectToXMLComposer::compose(std::list<sax::Token>& out, const Object& object) const {
	object.getData().Accept((void*) &out, alib::ToXMLComposers::toXMLComposers);
}

void ObjectToXMLComposer::compose(std::list<sax::Token>& out, const Void&) const {
	out.push_back(sax::Token(alib::Names::ALIB_VOID, sax::Token::TokenType::START_ELEMENT));
	out.push_back(sax::Token(alib::Names::ALIB_VOID, sax::Token::TokenType::END_ELEMENT));
}

void ObjectToXMLComposer::compose(std::list<sax::Token>& out, const ObjectBase& object) const {
	object.Accept((void*) &out, alib::ToXMLComposers::toXMLComposers);
}

} /* namespace alib */
