/*
 * Character.cpp
 *
 *  Created on: Mar 26, 2013
 *      Author: Jan Travicek
 */

#include "Character.h"

namespace primitive {

Character::Character(char data) : data(data) {

}

PrimitiveBase* Character::clone() const {
	return new Character(*this);
}

PrimitiveBase* Character::plunder() && {
	return new Character(std::move(*this));
}

char Character::getData() const {
	return data;
}

int Character::compare(const Character& other) const {
	return data - other.data;
}

void Character::operator>>(std::ostream& out) const {
	out << "(Character " << data << ")";
}

Character::operator std::string() const {
	return std::string(1, data);
}

} /* namespace primitive */

