/*
 * Integer.cpp
 *
 *  Created on: Mar 26, 2013
 *      Author: Jan Travnicek
 */

#include "Integer.h"

namespace primitive {

Integer::Integer(int data) : data(data) {

}

PrimitiveBase* Integer::clone() const {
	return new Integer(*this);
}

PrimitiveBase* Integer::plunder() && {
	return new Integer(std::move(*this));
}

int Integer::getData() const {
	return data;
}

int Integer::compare(const Integer& other) const {
	return data - other.data;
}

void Integer::operator>>(std::ostream& out) const {
	out << "(Integer " << data << ")";
}

Integer::operator std::string() const {
	return std::to_string(data);
}

} /* namespace primitive */

