/*
 * PrimitiveToXMLComposer.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnciek
 */

#ifndef PRIMITIVE_TO_XML_COMPOSER_H_
#define PRIMITIVE_TO_XML_COMPOSER_H_

#include <list>
#include <string>
#include "Primitive.h"
#include "../sax/Token.h"

namespace alib {

template<typename T>
struct xmlApi;

} /* namespace alib */

namespace primitive {

/**
 * This class contains methods to print XML representation of string to the output stream.
 */
class PrimitiveToXMLComposer {

	/**
	 * Prints XML representation of String to the output stream.
	 * @param string String to print
	 * @param out output stream to which print the String
	 */
	void compose(std::list<sax::Token>& out, const PrimitiveBase& primitive) const;

	/**
	 * Prints XML representation of String to the output stream.
	 * @param string String to print
	 * @param out output stream to which print the String
	 */
	void compose(std::list<sax::Token>& out, const Primitive& primitive) const;

	void compose(std::list<sax::Token>& out, const String& primitive) const;
	void compose(std::list<sax::Token>& out, const Integer& primitive) const;
	void compose(std::list<sax::Token>& out, const Character& primitive) const;
	void compose(std::list<sax::Token>& out, const Unsigned& primitive) const;
	void compose(std::list<sax::Token>& out, const Bool& primitive) const;

	void compose(std::list<sax::Token>& out, const std::string& primitive) const;
	void compose(std::list<sax::Token>& out, int primitive) const;
	void compose(std::list<sax::Token>& out, char primitive) const;
	void compose(std::list<sax::Token>& out, unsigned primitive) const;
	void compose(std::list<sax::Token>& out, bool primitive) const;

	template<typename T> friend class alib::xmlApi;
};

} /* namespace primitive */

#endif /* PRIMITIVE_TO_XML_COMPOSER_H_ */
