/*
 * String.h
 *
 *  Created on: Apr 10, 2013
 *      Author: Jan Travnicek
 */

#ifndef STRING_H_
#define STRING_H_

#include "../std/visitor.hpp"
#include "../std/compare.hpp"
#include "../common/wrapper.hpp"
#include "StringBase.h"
#include "../alphabet/Symbol.h"

namespace string {

/**
 * Wrapper around automata.
 */
typedef alib::wrapper<StringBase> String;

string::String stringFrom(const alphabet::Symbol& symbol);
string::String stringFrom(const std::string& str);

} /* namespace string */

namespace std {

template<>
struct compare<::string::String> {
	int operator()(const ::string::String& first, const ::string::String& second) const {
		return first.getData().compare(second.getData());
	}
};

} /* namespace std */

#endif /* STRING_H_ */

