/*
 * StringFromStringLexer.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#ifndef STRING_FROM_STRING_LEXER_H_
#define STRING_FROM_STRING_LEXER_H_

#include <string>
#include <sstream>

namespace string {

class StringFromStringLexer {
public:
	enum class TokenType {
		LESS,
		GREATER,
		QUOTE,
		EPSILON,
		TEOF,
		ERROR
	};

	struct Token {
		TokenType type;
		std::string value;
		std::string raw;
	};

	Token next(std::istream& input) const;
	void putback(std::istream&, Token token) const;
};

} /* namespace string */

#endif /* STRING_FROM_STRING_LEXER_H_ */
