/*
 * StringToStringComposer.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnciek
 */

#ifndef STRING_TO_STRING_COMPOSER_H_
#define STRING_TO_STRING_COMPOSER_H_

#include <ostream>
#include "String.h"

namespace string {

/**
 * This class contains methods to print XML representation of string to the output stream.
 */
class StringToStringComposer : public VisitableStringBase::const_visitor_type {
	void Visit(void*, const LinearString& string) const;
	void Visit(void*, const CyclicString& string) const;
	void Visit(void*, const Epsilon& string) const;
public:
	/**
	 * Prints XML representation of String to the output stream.
	 * @param string String to print
	 * @param out output stream to which print the String
	 */
	void compose(std::ostream& output, const String& string) const;
};

} /* namespace string */

#endif /* STRING_TO_STRING_COMPOSER_H_ */
