#include "StdSet.h"
#include <set>
#include <algorithm>

#include "alphabet/Symbol.h"

CPPUNIT_TEST_SUITE_REGISTRATION( StdSet );

void StdSet::setUp() {
}

void StdSet::tearDown() {
}

void StdSet::test1() {
	int first[] = {5,10,15,20,25};
	int second[] = {50,40,30,20,10};
	std::vector<int> v(10);                      // 0  0  0  0  0  0  0  0  0  0
	std::vector<int>::iterator it;

	std::sort (first,first+5);     //  5 10 15 20 25
	std::sort (second,second+5);   // 10 20 30 40 50

	it=std::set_difference (first, first+5, second, second+5, v.begin());
	v.resize(it-v.begin());

	CPPUNIT_ASSERT_EQUAL(5,  v[0]);
	CPPUNIT_ASSERT_EQUAL(15, v[1]);
	CPPUNIT_ASSERT_EQUAL(25, v[2]);
}


void StdSet::test2() {
	std::set<alphabet::Symbol> first  = {alphabet::symbolFrom(1)};
	std::set<alphabet::Symbol> second  = {alphabet::symbolFrom(1), alphabet::symbolFrom(2), alphabet::symbolFrom(3)};

	std::set<alphabet::Symbol> firstMinusSecond;
	std::set<alphabet::Symbol> secondMinusFirst;

	std::set_difference (first.begin(), first.end(), second.begin(), second.end(), std::inserter(firstMinusSecond, firstMinusSecond.end()));
	std::set_difference (second.begin(), second.end(), first.begin(), first.end(), std::inserter(secondMinusFirst, secondMinusFirst.end()));

	CPPUNIT_ASSERT_EQUAL(firstMinusSecond.size(), 0ul);
	CPPUNIT_ASSERT_EQUAL(secondMinusFirst.size(), 2ul);
}
